

{

Synchronize Copy
Linux/Windows
by Antti Kirjavainen
antti.kirjavainen@mail.htk.fi


You can do whatever you want with this code.

NOTE: FileLook-function was written by unknown author.

Console application for synchronizing two directories,
and can also remove any extra files from the destination
folder (files, that don't exist in the source folder).

Can do full recursive synchronization and checks any
changes to the files by the file size.

}


program SCOPY;

{$APPTYPE CONSOLE}

uses
        SysUtils, Classes {$IFDEF MSWINDOWS}, Windows{$ENDIF} {$IFDEF LINUX}, Libc{$ENDIF};

const
        ENTER = #13 + #10;
        extraFileDir = '_OTHER_FILES';
        ignoreList = 'SCOPY.LST';
        MD5Temp = '/tmp/.md5tmp';

var
	sourceDir: String;
        destDir: String;
        Pattern: String;
        parOptions: String;
        Recursive: Boolean;
        EraseOldFirst: Boolean;
        PauseBeforeCopy: Boolean;
        IgnoreCase: Boolean;
        OnlyDelete: Boolean;
	CalculateMD5: Boolean;
        oldFileAction: Integer; // 0 = Leave alone, 1 = Move to folder (oldFiles), 2 = Delete

        sourceFiles: TStringList;
        destFiles: TStringList;
        changedFiles: TStringList;
	ignoreFiles: TStringList;

        SizeCheck: Boolean;
        ErrorCount: Integer;
        CopyCount: Integer;
        DirCopyCount: Integer;
        SkipCount: Integer;
	IgnorelistCount: Integer;
        OldFileCount: Integer;
        OldFolderCount: Integer;
        CLine: String;
        sSlash: String;
        {$IFDEF LINUX}i: Integer;{$ENDIF}

procedure TypeToScreen(sText: String);
begin
// Type output to screen:
Writeln(sText);
end;

function AddSlash(sPath: String): string;
begin
// Add the trailing slash to a path, if missing:
if (Length(sPath) = 0) then begin
                            Result := sSlash;
                            exit;
                            end;
if (copy(sPath, Length(sPath), 1) <> sSlash) then Result := sPath + sSlash else Result := sPath;
end;

procedure DeleteFromList(sPath: String);
var
        i: Integer;

begin
// Delete subfolder entries from the list, since the main folder has been removed or moved:
sPath := AddSlash(sPath);

for i := 0 to destFiles.Count - 1 do begin
         if (Pos(sPath, AddSlash(destDir + destFiles.Strings[i])) > 0) then begin
                                                                                       destFiles.Strings[i] := '';
                                                                                       end;
end;

end;

{$IFDEF LINUX}
function FileCopy(const sourceFileName, targetFileName: String): Boolean;
var
        S, T: TFileStream;
begin
try
        S := TFileStream.Create(sourceFileName, fmOpenRead);
        T := TFileStream.Create(targetFileName, fmOpenWrite or fmCreate);

        try
                T.CopyFrom(S, S.Size);
        except
                Result := False;
                exit;
        end;
except
        Result := False;
        exit;
end;

T.Free();
S.Free();
Result := True;
end;
{$ENDIF}


function TimeStampOf(const FileName: string): Integer;
var
    aFileTime : Integer;
begin
    aFileTime := FileAge(FileName);
    Result := aFileTime;
end;

function FileSizeOf(const FileName: string): Int64;
var
  SearchRec: TSearchRec;
  sgPath   : String;
  inRetval : Integer;
begin
// Get file size by filename:
  sgPath   := ExpandFileName(FileName);
  Try
    inRetval := FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec);
    If inRetval = 0 Then
      Result := SearchRec.Size
    Else Result := -1;
  Finally
    SysUtils.FindClose(SearchRec);
  End;
end;

{
function FileSizeOf(const FileName: TFileName): Int64;
  var
    SearchRec: TSearchRec;
  begin
    if FindFirst(FileName, faAnyFile, SearchRec) = 0 then begin
      Result := (Int64(SearchRec.nFileSizeHigh) shl 32)
                 or SearchRec.nFileSizeLow;
      FindClose(SearchRec);
    end else
      Result := 0;
  end;
}

function FileLook(FileSpec: string; sPath: String; sList: TStringList): Boolean;
// Filespec must contain the full path ie. C:\FOLDER\* or C:\FOLDER\THIS.TXT, etc.
// This function searches all files and subfolders inside a folder.
var
        validres: integer; // Findfirst returns '0' only if there was no error.
        SearchRec: TSearchRec; // Required by 'FindFirst and FindNext' functions.
        DirPath, FullName, Flname, AddName: string;

{ SearchRec does not return the full path in the name variable in the record,
so 'DirPath' is used to store the full path name, and 'FullName' holds the
Full Path Name plus the file name or filter spec while 'Flname' holds
the filter or filename }

begin
DirPath := ExtractFilePath(FileSpec); // Keep track of the path ie: c:\folder\
Result := DirectoryExists(DirPath); // Check for valid directory - include FileCtrl in the uses statement.
if not (Result) then exit; // Invalid directory then exit.
Flname := ExtractFileName(FileSpec); // Keep track of the name or filter.
validres := FindFirst(FileSpec, faAnyFile, SearchRec); // Find first file.

while (validres = 0) do begin // If a matching file exists, loop
     if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then begin // Ignore . and .. dirs
     FullName := DirPath + SearchRec.Name;
     AddName := copy(FullName, Length(sPath) + 1, Length(FullName) - Length(sPath) + 1);
     if (Pos(sSlash, AddName) > 0) or (DirectoryExists(FullName)) then begin
                                     if (Recursive) then begin
                                                         sList.Add(AddName);
                                                         end;
                                     end
                                     else begin
                                     sList.Add(AddName);
                                     end;

// The above line assumes that the user wants the full path and file name...
// Note that at this point you can use the variable returned
// for example riteln(fs, fullname); or x:=TreeInsert(FullName, head);
// or you can do a compare to see if this is the file you were looking for, etc. etc.

     if (SearchRec.Attr and faDirectory > 0) then // It is a directory, not a file
     FileLook(FullName + sSlash + Flname, sPath, sList);
// The above line is the recursive call to search the subdirectory.
// The trailing slash is added to the path as well as the filter filter or filename.

     end; // End if statement.
     validres := FindNext(SearchRec); // Get next record before continuing conditional while loop
end; // End while loop
end;

procedure OrganizeList(sList: TStringList; bAscending: Boolean);
var
        listOrganize: TStringList;
        i: Integer;
        f: Integer;

begin
// When removing full folders with subfolders, the list needs to be organized
// by the length of the filenames (shortest names below). This way the files and
// subfolders get removed first, so that the main folders can be removed.
// However, when moving the files, the folders need to be created first, so then
// the order needs to be complete opposite (ascending).
try
        listOrganize := TStringList.Create();
        listOrganize.Text := sList.Text;
        sList.Clear();

        for i := 0 to listOrganize.Count - 1 do begin
                 if (sList.Count > 0) then begin
                 for f := 0 to sList.Count - 1 do begin
                                        if (bAscending) then begin
                                                             if (Length(sList.Strings[f]) >= Length(listOrganize.Strings[i])) or (f >= (sList.Count - 1)) then begin
                                                                                                                         if (sList.IndexOf(listOrganize.Strings[i]) < 0) then sList.Insert(f, listOrganize.Strings[i]);
                                                                                                                         end;
                                                             end
                                                             else begin
                                                             if (Length(sList.Strings[f]) <= Length(listOrganize.Strings[i])) or (f >= (sList.Count -1)) then begin
                                                                                                                         if (sList.IndexOf(listOrganize.Strings[i]) < 0) then sList.Insert(f, listOrganize.Strings[i]);
                                                                                                                         end;
                                                             end;
                 end;
                 end
                 else begin
                 sList.Add(listOrganize.Strings[i]);
                 end;
        end;

except
        //sList.Text := listOrganize.Text;
        exit;
end;

listOrganize.Free();
end;

function Ignore(sFileName: String): Boolean;
var
        i: Integer;

begin
// Does the ignore list contain any part of the filename?
if (ignoreFiles.Count <= 0) then begin
                                 Result := False;
                                 exit;
                                 end;

sFileName := UpperCase(sFileName);

for i := 0 to ignoreFiles.Count - 1 do begin
         if (Pos(UpperCase(ignoreFiles.Strings[i]), sFileName) > 0) then begin
                                                                         Result := True;
								         exit;
								         end;
end;

Result := False;
end;

function ChecksumChanged(sSourceDir: String; sDestDir: String; sFileName: String): Boolean;
{$IFDEF LINUX}
var
        tempMD5: TStringList;
        sCommand: String;
{$ENDIF}
begin
// This feature is only for Linux:
{$IFDEF MSWINDOWS}Result := False; exit;{$ENDIF}

// Executes the command "md5sum" to calculate checksums for both, source and destination files:
{$IFDEF LINUX}
if (DirectoryExists(IncludeTrailingBackSlash(sSourceDir) + sFileName)) then begin
                                                                            Result := False;
                                                                            exit;
                                                                            end;

try
        sCommand := 'cd "' + sSourceDir + '" && md5sum "' + sFileName + '" >' + MD5Temp;
        Libc.system(PChar(sCommand));
        sCommand := 'cd "' + sDestDir + '" && md5sum "' + sFileName + '" >>' + MD5Temp;
        Libc.system(PChar(sCommand));
        if not (FileExists(MD5Temp)) then begin
                                          Result := False;
                                          exit;
                                          end;

        tempMD5 := TStringList.Create();
        tempMD5.Clear();
        tempMD5.LoadFromFile(MD5Temp);
        //Libc.system(PChar('cat ' + MD5Temp));
        if (tempMD5.Count < 2) then begin
                                    Result := False;
                                    exit;
                                    end;
        if (tempMD5.Strings[0] = tempMD5.Strings[1]) then Result := False else Result := True;
        tempMD5.Free();

except
        Result := False;
end;

if (FileExists(MD5Temp)) then DeleteFile(MD5Temp);
{$ENDIF}
end;

function FileHasChanged(sSourceFile: String; sDestFile: String): Boolean;
begin
if (SizeCheck) then begin
                    if (FileSizeOf(sSourceFile) = FileSizeOf(sDestFile)) then begin
                                                                              Result := False;
                                                                              end
                                                                              else begin
                                                                              Result := True;
                                                                              end;
                    end
                    else begin
                    if (TimeStampOf(sSourceFile) = TimeStampOf(sDestFile)) then begin
                                                                                Result := False;
                                                                                end
                                                                                else begin

//TypeToScreen(IntToStr(TimeStampOf(sSourceFile)) + '-' + IntToStr(TimeStampOf(sDestFile)));
                                                                                Result := True;
                                                                                end;
                    end;
end;

function FileChanged(sFileName: String): Boolean;
var
        i: Integer;
        s1: String;
        s2: String;

begin
// Is the file in the destination folder different size (therefore changed)?
s1 := sFileName;
if (IgnoreCase) then s1 := LowerCase(s1);

for i := 0 to destFiles.Count - 1 do begin
        s2 := destFiles.Strings[i];
        if (IgnoreCase) then s2 := LowerCase(s2);

        if (s1 = s2) then begin
                                                              destFiles.Delete(i);
							      if not (FileHasChanged(destDir + sFileName, sourceDir + sFileName)) then begin
                                                                                                                                            if (DirectoryExists(sourceDir + sFileName)) then begin
                                                                                                                                                                                             Result := False;
                                                                                                                                                                                             end
                                                                                                                                                                                             else begin
                                                                                                                                                                                             if (CalculateMD5) then Result := ChecksumChanged(sourceDir, destDir, sFileName) else Result := False;
                                                                                                                                                                                             end;
                                                                                                                                            exit;
                                                                                                                                            end
                                                                                                                                            else begin
                                                                                                                                            Result := True;
                                                                                                                                            if (DirectoryExists(sourceDir + sFileName)) then Result := False; // Directory sizes may vary on different filesystems
                                                                                                                                            exit;
                                                                                                                                            end;
                                                              end;
end;

Result := True;
end;

procedure LoadIgnorelist();
begin
// Load the ignore list file to ignoreFiles-TStringList:
ignoreFiles.Clear();

try
        if (FileExists(sourceDir + ignoreList)) then begin
                                                     ignoreFiles.LoadFromFile(sourceDir + ignoreList);
                                                     TypeToScreen('Ignore list found (' + sourceDir + ignoreList + ')...');
                                                     end;
except
        ErrorCount := ErrorCount + 1;
        ignoreFiles.Clear();
        TypeToScreen('Opening ignore list ' + sourceDir + ignoreList + ' failed...');
end;

end;

function ShowPrompt(): Boolean;
var
        UserPrompt: String;

begin
TypeToScreen('');
TypeToScreen('Ready to start copying. ' + IntToStr(changedFiles.Count) + ' changed file(s) and ' + IntToStr(destFiles.Count) + ' extra file(s) found.');
TypeToScreen('Press L to list changed files, E to list extra files, X to abort, any other key to continue.');
UserPrompt := '';
Readln(UserPrompt);
UserPrompt := UpperCase(UserPrompt);

if (Pos('L', UserPrompt) > 0) then begin
                                   TypeToScreen(changedFiles.Text);
                                   Result := ShowPrompt();
                                   exit;
                                   end;

if (Pos('E', UserPrompt) > 0) then begin
                                   TypeToScreen(destFiles.Text);
                                   Result := ShowPrompt();
                                   exit;
                                   end;

if (Pos('X', UserPrompt) > 0) then begin
                                   TypeToScreen('Aborted by user.');
                                   Result := False;
                                   exit;
                                   end;

Result := True;
end;

function CreateLists(): Boolean;
var
        i: Integer;
        Success: Boolean;

begin
// Reset variables and create all TStringLists, ready for operation:
try
ErrorCount := 0;
CopyCount := 0;
SkipCount := 0;
IgnorelistCount := 0;

Success := ForceDirectories(destDir);
if not (Success) then begin
                      TypeToScreen('Unable to find or create destination folder ' + destDir + '.');
                      Result := False;
                      exit;
                      end;


sourceDir := AddSlash(sourceDir);
destDir := AddSlash(destDir);

sourceFiles := TStringList.Create();
destFiles := TStringList.Create();
changedFiles := TStringList.Create();
ignoreFiles := TStringList.Create();
sourceFiles.Clear();
destFiles.Clear();
changedFiles.Clear();


if (Recursive) then TypeToScreen('Synchronizing folders recursively.') else TypeToScreen('Not synchronizing folders recursively.');
if (EraseOldFirst) then TypeToScreen('Erasing old files first instead of overwriting.');
if (SizeCheck) then TypeToScreen('Checking filesizes instead of timestamps.');
if (IgnoreCase) then TypeToScreen('Ignoring case in folder and filenames.');
if (oldFileAction = 0) then TypeToScreen('Leaving extra files in destination folder intact.');
if (oldFileAction = 1) then TypeToScreen('Moving extra files from destination folder to ' + destDir + extraFileDir);
if (oldFileAction = 2) then TypeToScreen('Deleting any extra files from destination folder ' + destDir);
if (OnlyDelete) then TypeToScreen('Only deleting extra files, skipping copy');

LoadIgnorelist();

TypeToScreen('Preparing folder ' + sourceDir + '...');
Success := FileLook(sourceDir + Pattern, sourceDir, sourceFiles);

if not (Success) then begin
                      TypeToScreen('Searching for files in source folder ' + sourceDir + ' failed.');
                      Result := False;
                      exit;
                      end;

if (sourceFiles.Count <= 0) then begin
                              TypeToScreen('No files found from the source folder ' + sourceDir + '.');
                              Result := False;
                              exit;
                              end;

TypeToScreen('Preparing folder ' + destDir + '...');
FileLook(destDir + Pattern, destDir, destFiles);

TypeToScreen('Comparing files...');
if (CalculateMD5) then TypeToScreen('Calculating MD5 checksums. 100 % accurate, but slow with big files.');
TypeToScreen('');

// Let's see, which files have been changed and which ones will be ignored:
for i := 0 to sourceFiles.Count - 1 do begin
         if (FileChanged(sourceFiles.Strings[i])) then begin
                                                    if (Ignore(sourceDir + sourceFiles.Strings[i])) then begin
											                 IgnorelistCount := IgnorelistCount + 1;
											                 end
											                 else begin
													 changedFiles.Add(sourceFiles.Strings[i]);
											                 end;
                                                    end
                                                    else begin
                                                    SkipCount := SkipCount + 1;
                                                    end;
end;

except
        TypeToScreen('Aborted by user.');
        Result := False;
        exit;
end;


if (PauseBeforeCopy) then begin
                          if (ChangedFiles.Count > 0) or (destFiles.Count > 0) then begin
                                                                                    Result := ShowPrompt();
                                                                                    exit;
                                                                                    end;
                          end;

Result := True;
end;

procedure CopyChanged();
var
        fullCount: Integer;
        curFolder: String;
        Success: Boolean;
        IsDir: Boolean;
        i: Integer;

begin
// Copy the changed files to destination folder:
if not (OnlyDelete) then begin
fullCount := changedFiles.Count;

for i := 0 to fullCount - 1 do begin
         if (Length(changedFiles.Strings[i]) > 0) then begin
         try
                IsDir := DirectoryExists(sourceDir + changedFiles.Strings[i]);

                if not (IsDir) then begin // Copy the filename, it's not a directory
                                    curFolder := ExtractFileDir(destDir + changedFiles.Strings[i]);
                                    ForceDirectories(curFolder);
                                    if (EraseOldFirst) then begin
                                                            TypeToScreen('Erasing ' + destDir + changedFiles.Strings[i]);
							    DeleteFile(PChar(destDir + changedFiles.Strings[i]));
							    end;
                                    TypeToScreen('[' + IntToStr(i + 1) + '/' + IntToStr(fullCount) + '] Copying ' + changedFiles.Strings[i] + '');
				    {$IFDEF MSWINDOWS}Success := CopyFile(PChar(sourceDir + changedFiles.Strings[i]), PChar(destDir + changedFiles.Strings[i]), False);{$ENDIF}
                                    {$IFDEF LINUX}Success := FileCopy(sourceDir + changedFiles.Strings[i], destDir + changedFiles.Strings[i]);{$ENDIF}
                                    FileSetDate(destDir + changedFiles.Strings[i], TimeStampOf(sourceDir + changedFiles.Strings[i]));
				    if (Success) then begin
                                                      CopyCount := CopyCount + 1
                                                      end
                                                      else begin
                                                      ErrorCount := ErrorCount + 1;
                                                      TypeToScreen('...failed');
                                                      end;
                                    end
                                    else begin // Create the current folder, since the filename is a directory
                                    TypeToScreen('[' + IntToStr(i + 1) + '/' + IntToStr(fullCount) + '] Creating folder ' + changedFiles.Strings[i] + '');
                                    Success := ForceDirectories(destDir + changedFiles.Strings[i]);
                                    if (Success) then begin
                                                      DirCopyCount := DirCopyCount + 1
                                                      end
                                                      else begin
                                                      ErrorCount := ErrorCount + 1;
                                                      TypeToScreen('...failed');
                                                      end;
                                    end;
         except
                ErrorCount := ErrorCount + 1;
                TypeToScreen('...failed');
         end;
                                                        end;
end;
end;

// ...and finally, done. Display the results:
TypeToScreen('');
TypeToScreen('Synchronized folder ' + sourceDir + ' with ' + destDir);
TypeToScreen('--------------------------------------------------------------------------------');
if (oldFileAction = 0) then TypeToScreen(IntToStr(oldFileCount) + ' extra file(s) and ' + IntToStr(oldFolderCount) + ' folder(s) found from destination folder.');
if (oldFileAction = 1) then TypeToScreen(IntToStr(oldFileCount) + ' extra file(s) and ' + IntToStr(oldFolderCount) + ' folder(s) moved to ' + destDir + extraFileDir + '.');
if (oldFileAction = 2) then TypeToScreen(IntToStr(oldFileCount) + ' extra file(s) and ' + IntToStr(oldFolderCount) + ' folder(s) deleted from destination folder.');
TypeToScreen(IntToStr(IgnorelistCount) + ' ignored file(s) and folder(s) skipped.');
TypeToScreen(IntToStr(SkipCount) + ' unchanged file(s) and folder(s) skipped.');
TypeToScreen(IntToStr(DirCopyCount) + ' folder(s) created.');
TypeToScreen(IntToStr(CopyCount) + ' file(s) copied.');
TypeToScreen(IntToStr(ErrorCount) + ' error(s).');
end;

procedure HandleOld();
var
        fullCount: Integer;
        IsDir: Boolean;
        Success: Boolean;
        i: Integer;
begin
// A bit complicated procedure.
// Moves, deletes or leaves alone any extra files in the destination folder:
if (OldFileAction = 1) then OrganizeList(destFiles, True) else OrganizeList(destFiles, False);

fullCount := destFiles.Count;
if (fullCount = 0) then exit; // No extra files found from the destination folder


if (oldFileAction = 1) then begin // Create the extraFileDir, if we are moving any extra files there:
                            Success := ForceDirectories(destDir + extraFileDir);
                            if not (Success) then begin
                                                  TypeToScreen('Unable to find or create folder ' + destDir + extraFileDir + '.');
                                                  TypeToScreen('Old files left intact.');
                                                  ErrorCount := ErrorCount + fullCount;
                                                  exit;
                                                  end;
                            end;

                            
for i := 0 to fullCount - 1 do begin // Do the specified action to the extra files
if (Length(destFiles.Strings[i]) > 0) and (Pos(extraFileDir, destFiles.Strings[i]) = 0) then begin // extraFileDir is being ignored, just like empty entries in the TStringList
         if not (Ignore(destFiles.Strings[i])) then begin // Is the extra file on the ignore list?
         try
         if (DirectoryExists(destDir + destFiles.Strings[i])) then IsDir := True else IsDir := False;
                if (oldFileAction = 0) then begin // We're doing nothing for the extra files (/L-parameter). Just counting them.
                                            if not (IsDir) then OldFileCount := OldFileCount + 1 else OldFolderCount := OldFolderCount + 1;
                                            end;
                if (oldFileAction = 1) then begin // Moving the extra files to destDir + extraFileDir (/M-parameter)
                                            TypeToScreen('Moving ' + destDir + destFiles.Strings[i] + ' to ' + destDir + extraFileDir);
					    if not (IsDir) then begin // File move
                                                                ForceDirectories(AddSlash(destDir + extraFileDir) + ExtractFilePath(destFiles.Strings[i]));
                                                                {$IFDEF MSWINDOWS}Success := MoveFile(PChar(destDir + destFiles.Strings[i]), PChar(AddSlash(destDir + extraFileDir) + destFiles.Strings[i]));{$ENDIF}
                                                                {$IFDEF LINUX}
                                                                        Success := FileCopy(destDir + destFiles.Strings[i], AddSlash(destDir + extraFileDir) + destFiles.Strings[i]);
                                                                        DeleteFile(destDir + destFiles.Strings[i]);
                                                                {$ENDIF}
                                                                RemoveDir(destDir + ExtractFilePath(destFiles.Strings[i]));
                                                                end
                                                                else begin // Folder move
                                                                ForceDirectories(AddSlash(destDir + extraFileDir) + destFiles.Strings[i]);
                                                                RemoveDir(destDir + destFiles.Strings[i]);
                                                                Success := True;
                                                                end;
                                            if not (Success) then begin
                                                                  TypeToScreen('...failed');
                                                                  ErrorCount := ErrorCount + 1;
                                                                  end
                                                                  else begin
                                                                  if not (IsDir) then OldFileCount := OldFileCount + 1 else OldFolderCount := OldFolderCount + 1;
                                                                  end;
                                            end;
                if (oldFileAction = 2) then begin // Deleting the extra files from destDir (/D-parameter)
                                            if not (IsDir) then begin // File delete
                                                                TypeToScreen('Deleting ' + destDir + destFiles.Strings[i]);
                                                                Success := DeleteFile(PChar(destDir + destFiles.Strings[i]))
                                                                end
                                                                else begin // Folder delete
                                                                TypeToScreen('Deleting folder ' + destDir + destFiles.Strings[i]);
                                                                Success := RemoveDir(destDir + destFiles.Strings[i]);
                                                                end;
                                            if not (Success) then begin
                                                                  TypeToScreen('...failed');
                                                                  ErrorCount := ErrorCount + 1;
                                                                  end
                                                                  else begin
                                                                  if not (IsDir) then OldFileCount := OldFileCount + 1 else OldFolderCount := OldFolderCount + 1;
                                                                  end;
                                            end;

         except
                ErrorCount := ErrorCount + 1;
                TypeToScreen('...failed');
         end;
                                                   end
                                                   else begin // Ignore = True
                                                   IgnorelistCount := IgnorelistCount + 1;
                                                   end;
                                                                                                        end;
end;

TypeToScreen('');
end;

function Parameters(fullString: String): Boolean;
var
        i: Integer;

begin
// Handle the command line parameters and set variables according to them:
sourceDir := '';
destDir := '';
Pattern := '';
parOptions := '';
oldFileAction := 0;

for i := 1 to ParamCount do begin
         if (Length(ParamStr(i)) > 0) then begin
                                             if (Copy(ParamStr(i), 1, 1) = '-') then begin // First we look for the switches (-R, -D, etc.)
                                                                                   parOptions := parOptions + UpperCase(ParamStr(i));
                                                                                   end
                                                                                   else begin // ...then for paths, first sourceDir and then destDir
                                                                                   if (Length(sourceDir) <= 0) then sourceDir := ParamStr(i) else destDir := ParamStr(i);
                                                                                   end;
                                             end;
end;

if (Length(sourceDir) <= 0) or (Length(destDir) <= 0) then begin
                                                           TypeToScreen('Command line parameters missing. -? for help.');
                                                           Result := False;
                                                           exit
                                                           end;

if not (DirectoryExists(sourceDir)) then begin // Separate pattern from the sourceDir (eg. C:\FOLDER\*.TXT)
                                         Pattern := ExtractFilename(sourceDir);
                                         sourceDir := copy(sourceDir, 1, Length(sourceDir) - Length(Pattern) - 1);
                                         end;

if not (DirectoryExists(sourceDir)) then begin // ...but if the folder still does not exist
                                         if (Pos(sSlash, sourceDir) = 0) then begin // No source folder given, assume current folder
                                                                           Pattern := sourceDir;
                                                                           sourceDir := '.';
                                                                           end
                                                                           else begin
                                                                           TypeToScreen('Source folder not found.');
                                                                           Result := False;
                                                                           exit;
                                                                           end;
                                         end;


if (Length(Pattern) <= 0) then Pattern := '*';

if (Pos('R', parOptions) > 0) then Recursive := True else Recursive := False;
if (Pos('E', parOptions) > 0) then EraseOldFirst := True else EraseOldFirst := False;
if (Pos('S', parOptions) > 0) then SizeCheck := True else SizeCheck := False;
if (Pos('P', parOptions) > 0) then PauseBeforeCopy := True else PauseBeforeCopy := False;
if (Pos('L', parOptions) > 0) then oldFileAction := 0;
if (Pos('M', parOptions) > 0) then oldFileAction := 1;
if (Pos('D', parOptions) > 0) then oldFileAction := 2;
if (Pos('O', parOptions) > 0) then oldFileAction := 2;
if (Pos('5', parOptions) > 0) then CalculateMD5 := True else CalculateMD5 := False;
if (Pos('I', parOptions) > 0) then IgnoreCase := True else IgnoreCase := False;
if (Pos('O', parOptions) > 0) then OnlyDelete := True else OnlyDelete := False;

Result := True;
end;





// -----------------------------------------------------------------------------
// Main program code:
// -----------------------------------------------------------------------------
begin
{$IFDEF MSWINDOWS}sSlash := '\';{$ENDIF}
{$IFDEF LINUX}sSlash := '/';{$ENDIF}

{$IFDEF MSWINDOWS}CLine := CMDLine;{$ENDIF}
{$IFDEF LINUX}
CLine := '';
for i := 0 to ParamCount do begin
        CLine := CLine + ' ' + ParamStr(i);
end;
{$ENDIF}

if (Pos('-?', CLine) > 0) or (Pos('--help', CLine) > 0) or (ParamCount = 0) then begin
                                                     TypeToScreen('');
                                                     TypeToScreen('Synchronization Copy v2.4');
                                                     TypeToScreen('');
                                                     TypeToScreen('http://www.htk.fi/public/akirjavainen');
                                                     TypeToScreen('Antti Kirjavainen <antti.kirjavainen@mail.htk.fi>');
                                                     TypeToScreen('');
                                                     TypeToScreen('Usage:');
                                                     TypeToScreen('scopy [parameters] source_path destination_path');
                                                     TypeToScreen('');
                                                     TypeToScreen('-? = This help screen');
                                                     TypeToScreen('-R = Copy recursively including all subfolders and files');
                                                     TypeToScreen('-E = Erase old files first, instead of overwriting them');
                                                     TypeToScreen('-S = Check file changes from its size instead of timestamp');
                                                     TypeToScreen('-P = Pause before starting the actual copying process');
                                                     TypeToScreen('-I = Ignore case differences in folders and filenames');
                                                     TypeToScreen('-L = Leave extra files in destination folder intact (default)');
                                                     TypeToScreen('-M = Move extra files from destination to ' + extraFileDir);
                                                     TypeToScreen('-D = Delete extra files from destination folder');
						     TypeToScreen('-O = Only delete extra files, do not copy anything');
                                                     {$IFDEF LINUX}TypeToScreen('-5 = Also calculate MD5 checksums for 100 % match');{$ENDIF}
                                                     TypeToScreen('');
                                                     exit;
                                                     end;

if not (Parameters(CLine)) then exit; // Missing parameters
if not (CreateLists()) then exit; // Error creating lists or folders
HandleOld(); // First handle the extra files
CopyChanged(); // ...then synchronize

end.